<template>
  <v-container id="input-usage" fluid>
    <v-img class="mx-auto my-6" max-width="228" src=""></v-img>
    <div v-if="error">
      <h3 class="text-center">{{ error }}</h3>
    </div>
    <div v-else>
      <v-card
        class="mx-auto pa-4 pb-8"
        elevation="8"
        max-width="500"
        rounded="lg"
      >
        <v-card-item>
          <v-card-title>
            <p class="text-h4">Chọn file</p>
          </v-card-title>
        </v-card-item>

        <v-card-text>
          <v-row>
            <v-col cols="12">
              <v-file-input
                show-size
                accept="files/xlsx"
                counter
                multiple
                ref="fileInput"
                label="files upload"
                variant="solo-filled"
                @change="handleFileUpload()"
                >Nhập file
              </v-file-input>

              <div>
                <v-btn
                  class="me-4"
                  type="submit"
                  :loading="loading"
                  :disabled="disabled == 1"
                  @click="submitFileUpload()"
                >
                  Lưu
                </v-btn>
              </div>
            </v-col>
          </v-row>
        </v-card-text>
        <v-card-item>
          <v-card-subtitle>
            <v-alert
              v-model="alert"
              border="left"
              close-text="Close Alert"
              color="error"
              dark
              dismissible
              max-width="450"
              height="auto"
              class=""
            >
              <div
                style="overflow-x: auto; white-space: nowrap"
                v-html="message"
              ></div>
            </v-alert>
          </v-card-subtitle>
        </v-card-item>
      </v-card>
    </div>
  </v-container>
</template>
<script>
import { ref, onMounted } from "vue";
import { useRoute } from "vue-router";
import { getIdSupplier } from "@/api/login";
import swal from "sweetalert2";
import { uploadFileById } from '@/api/upload';

export default {
  setup() {
    const route = useRoute();
    const loading = ref(false);
    const disabled = ref(false);
    const fileInput = ref(null);
    const error = ref("");
    const message = ref(false);
    const type = ref(false);
    const alert = ref(false);
    const id = route.params.id

    onMounted(() => {
      fileInput;
    });

    const getInfoSupplier = async () => {
      try {
        await getIdSupplier(id).then((res) => res.data);
      } catch (err) {
        error.value = err.response.data.message;
      }
    };
    function handleFileUpload() {
      let file = fileInput.value.files[0];
      if (!file || file.name.split(".").pop() != "xlsx") {
        //check if file extension is xlsx
        swal.fire("Đã có lỗi", "Vui lòng chọn file định dạng .xlsx", "error");
        disabled.value = true;
        return;
      } else {
        alert.value = false;
        disabled.value = false;
      }
    }
    function submitFileUpload() {
      loading.value = true;
      let file = fileInput.value.files[0];
      let formData = new FormData();
      formData.append("import_excel_file", file);
       formData.append("id", id);
      uploadFileById(formData)
        .then((res) => {
          let data = res.data;
          if (data) {
            swal.fire("Thành công", "Nhập file thành công", "success");
            window.location.reload();
          }
        })
        .catch((err) => {
          console.log(err);
          alert.value = true;
          let arrErr = err.response.data;
          if (arrErr) {
            if (arrErr.data.length > 0) {
              swal.fire(arrErr.message, "", "error");
              message.value = arrErr.data.join("<br/>");
            } else {
              message.value = arrErr.message;
            }
            return;
          }
          message.value = "Lỗi hệ thống";
          return;
        })
        .finally(() => {
          loading.value = false;
        });
    }
    

    getInfoSupplier();

    return {
      loading,
      disabled,
      fileInput,
      message,
      type,
      error,
      alert,
      handleFileUpload,
      submitFileUpload,
    };
  },
};
</script>